Subject: Message-Passing WG of JGF

From: Vladimir Getov <[email-masked]>
Date: Wed, 19 May 1999 17:44:20 +0100 (BST)

Hi all,

There was an e-mail exchange last week between Marc Snir, Rusty Lusk
and myself regarding the position of our activities and in particular
our contacts and collaboration with the MPI forum. I personally
feel that this was important for our joint work and thought that I
should share some of the most informative messages with the whole
group. I think it is natural for the Message-Passing WG of JGF to
undertake mainly collaborative research and development of PORTABLE 
message-passing frameworks and corresponding APIs for Java and
forward any draft standard proposals (e.g. Java-MPI) whenever they
are ready to the MPI forum for the OFFICIAL standardization procedure.

In my view, this clarification does not impose any changes to our
topics for discussion and joint work with one small exception -
we should be careful with the abbreviation "MPI" and try to replace
it by "MPI-like" in our text documents. The names of the functions
also need a slight change (pls. see Rusty's message below).

Other views or comments please.

Regards,
		-Vladimir

---------- Forwarded message ----------
Date: Thu, 13 May 1999 11:36:17 -0500
From: Rusty Lusk <[email-masked]>
To: Vladimir Getov <[email-masked]>
Cc: [email-masked], Geoffrey Fox <[email-masked]>, [email-masked],
    Siamak Hassanzadeh <[email-masked]>,
    gannon <[email-masked]>
Subject: Re: URGENT - Java-MPI 

Dear Vladimir,

     I concur with Marc's caution that the Java Grande group make it
clear that it is not standardizing "the" Java binding for MPI.  The 
MPI Forum, which has been in operation since 1993, has taken on the
responsibility of defining language bindings for the MPI functions, and
its formal procedures have been successful creating a general
acceptance of the MPI Standard, including its language bindings.  The
members of the MPI Forum would prefer that you treat yourself as an
"exploratory working group" rather than a "standardization body".  
I was pleased to read your reply to Marc Snir, in which you indicate that
you understand the issues involved well.

     A somewhat similar situation occurred with regard to the standardization
of parallel I/O routines in MPI.  At first there was a small group, then a
larger group functioning by email, discussing what an MPI interface to
parallel I/O would look like.  This group included both MPI Forum members and
non-members.  The Forum eventually voted to bring them in as an official Forum
group.  Much further discussion and refinement of the interface then took
place in the context of the full Forum.  The result was that MPI-IO is one of
the most important and earliest-implemented parts of the MPI-2 standard, and
is covered in current and upcoming books on MPI.  One of the ways in which the
MPI-IO working group made it clear that it was not prematurely claiming "MPI
Standard" status was by avoiding the standard MPI_ prefix in its
implementation work.  I.e., they used MPIO_Open, for example, instead of
MPI_Open.  Later, when the Forum released the Standard, of course, it was
MPI_Open, like all the MPI standard functions.  The Java Grande group could
perhaps do the same sort of thing by calling the functions MPIJ_Send or
JMPI_Send while things are still in the exploratory stage.

     I am happy about the effort to make Java a real force in high-performance
computing, and of course pleased that MPI is considered a critical component
of this effort.  Please stay in touch, and I would very much appreciate being
on your group's mailing list.

Regards,
Rusty Lusk

On Thu, 13 May 1999 Vladimir Getov wrote:

| Marc,
| 
| I appreciate your comments and find them very useful for our work.
| We touched this important issue during the discussion at MPIDC'99
| in March but your message helps to clearly distinguish between the
| objectives of our working group and the standardization activities
| of the MPI forum. In particular, I suggest we adopt the name
| "Message Passing WG of the Java Grande forum" with the main aim
| "to provide an environment for discussion and collaboration in the
| research and development of portable message-passing frameworks and
| corresponding APIs for the Java programming language with focus on
| JavaGrande applications". Important current objectives are the 
| development of an MPI-like API for Java,  reserach into O-O 
| Java-centric message-passing environments as well as performance
| evaluation and comparisons between different frameworks and
| implementations.
| 
| In addition to us being part of Java Grande we'll keep in touch
| with the MPI forum (some of its members subscribe to our group as
| well). This will make it easier to forward the relevant information
| and draft documents to the MPI forum if and when the result of our
| work is mature enough to start a standardization procedure. Hope this 
| is in line with your views. I'd be grateful for any comments/reaction 
| from Geoffrey, Rusty and Bill.
| 
| Regards,
| 		-Vladimir

On Wed, 12 May 1999 [email-masked] wrote:

> Vladimir, 
> the MPI forum maintains the MPI standard. A binding of MPI to a new
> language will have to be discussed and voted by the members of the 
> MPI forum, using the same process that was used in MPI1 and MPI2. A 
> lot of people (myself included) will be quite upset if you try to set 
> up another process -- and this is likely to slow down, rather than 
> accelerate, the acceptance of your work.
>
> When I, and other people, worked on MPI-IO before this was part of 
> the MPI standard, we where very careful to indicate that this activity 
> is not part of the MPI standardization effort, and did not use the MPI 
> prefix in function names, to prevent confusion. We could drive our 
> effort autonomously, we could deploy at major sites (NASA, LLNL,...) 
> our MPI-IO library, and, when time was ripe, could jump-start an MPI 
> forum activity based on the state of MPI-IO at that point in time. The 
> final design ended up quite close (but far from not identical) to  what 
> we had worked on our own. 
>
> I would encourage you to follow up the same process: make clear this is 
> not an effort to develop a standard binding for MPI in Java, but a 
> collaborative research effort on the subject of MPI-like messaging from 
> Java. These nuances may sound silly, but you have to remember that MPI 
> is mandated in many procurements, so what is "MPI" has significant
> commercial implications.
> 
> 
> 
> Marc Snir
> Senior Manager, Scalable Parallel Systems
> IBM T J Watson Research Center, PO Box 218, Yorktown Heights 10598
> Tel: 914 945 3204 (862 3204) Fax: 914 945 4425 (862 4425)
> URL: http://www.research.ibm.com/people/s/snir
> 
> 
>

---

From: Eric Sharakan - Sun High Performance Computing <[email-masked]>
Date: Thu, 20 May 1999 12:47:20 -0400 (EDT)

[My apologies to those who are seeing this twice, by virtue of being on both the 
java-mpi and javagrandeforum mailing lists.  I munged the address for the latter 
in my original message.]

------------- Begin Forwarded Message -------------

X-Authentication-Warning: postoffice.npac.syr.edu: majordom set sender to 
[email-masked] using -f
Date: Thu, 20 May 1999 12:39:56 -0400 (EDT)
From: Eric Sharakan - Sun High Performance Computing 
<[email-masked]>
Subject: Re: Message-Passing WG of JGF
To: [email-masked]
Cc: [email-masked]
MIME-Version: 1.0
Content-MD5: vaCxINzsEUPapv10viUIhg==

Folks:

I agree that following the MPI-IO precedent for our work on the Java language 
bindings for MPI makes good sense.  I also concur that this group is (or should 
be) interested in more than these bindings (e.g. other Java-centric messaging 
technologies).

I do feel that coming to an agreement on a draft proposal for these bindings, 
and passing them on to the MPI Forum, should be our top short-term priority.  
Ideally, we would establish a timetable whereby we'd aim to have a draft ready 
for handoff to the Forum by some specific date.  If, in return, the MPI Forum 
could commit to a timely discussion and vote on these bindings, it would be a 
win for all involved.

Now, I realize that our (the Sun HPC Engineering) organization's involvement in 
this working group has been late in coming, and that we're still working to come 
up to speed on the relevant issues.  Still, I don't think it too presumptuous 
for us to request that we attempt to come up with just such a timetable during 
our meeting at JG next month.

-Eric Sharakan

> X-Authentication-Warning: postoffice.npac.syr.edu: majordom set sender to 
[email-masked] using -f
> Date: Wed, 19 May 1999 17:44:20 +0100 (BST)
> From: Vladimir Getov <[email-masked]>
> X-Sender: getovv@jaguar
> To: [email-masked]
> cc: [email-masked]
> Subject: Message-Passing WG of JGF
> MIME-Version: 1.0
> 
> Hi all,
> 

------------- End Forwarded Message -------------